/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the Task type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Task{}

// Task struct for Task
type Task struct {
	Id string `json:"id"`
	OrganizationId string `json:"organization_id"`
	InteractionId *string `json:"interaction_id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	ScriptId *string `json:"script_id,omitempty"`
	Text string `json:"text"`
	Title string `json:"title"`
	Type string `json:"type"`
	Blocker bool `json:"blocker"`
	CreatedAt *string `json:"created_at,omitempty"`
	UpdatedAt *string `json:"updated_at,omitempty"`
	OwnedBy *string `json:"owned_by,omitempty"`
	DestinationLink *string `json:"destination_link,omitempty"`
	Interval *string `json:"interval,omitempty"`
	ScheduleType *string `json:"schedule_type,omitempty"`
	Action *string `json:"action,omitempty"`
	Usages []string `json:"usages,omitempty"`
	Element *TaskElement `json:"element,omitempty"`
	TasksCompletions []TaskCompletion `json:"tasks_completions,omitempty"`
}

// NewTask instantiates a new Task object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTask(id string, organizationId string, text string, title string, type_ string, blocker bool) *Task {
	this := Task{}
	this.Id = id
	this.OrganizationId = organizationId
	this.Text = text
	this.Title = title
	this.Type = type_
	this.Blocker = blocker
	return &this
}

// NewTaskWithDefaults instantiates a new Task object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTaskWithDefaults() *Task {
	this := Task{}
	return &this
}

// GetId returns the Id field value
func (o *Task) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Task) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Task) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Task) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Task) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Task) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *Task) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *Task) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *Task) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *Task) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *Task) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *Task) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetScriptId returns the ScriptId field value if set, zero value otherwise.
func (o *Task) GetScriptId() string {
	if o == nil || IsNil(o.ScriptId) {
		var ret string
		return ret
	}
	return *o.ScriptId
}

// GetScriptIdOk returns a tuple with the ScriptId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetScriptIdOk() (*string, bool) {
	if o == nil || IsNil(o.ScriptId) {
		return nil, false
	}
	return o.ScriptId, true
}

// HasScriptId returns a boolean if a field has been set.
func (o *Task) HasScriptId() bool {
	if o != nil && !IsNil(o.ScriptId) {
		return true
	}

	return false
}

// SetScriptId gets a reference to the given string and assigns it to the ScriptId field.
func (o *Task) SetScriptId(v string) {
	o.ScriptId = &v
}

// GetText returns the Text field value
func (o *Task) GetText() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Text
}

// GetTextOk returns a tuple with the Text field value
// and a boolean to check if the value has been set.
func (o *Task) GetTextOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Text, true
}

// SetText sets field value
func (o *Task) SetText(v string) {
	o.Text = v
}

// GetTitle returns the Title field value
func (o *Task) GetTitle() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Title
}

// GetTitleOk returns a tuple with the Title field value
// and a boolean to check if the value has been set.
func (o *Task) GetTitleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Title, true
}

// SetTitle sets field value
func (o *Task) SetTitle(v string) {
	o.Title = v
}

// GetType returns the Type field value
func (o *Task) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Task) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Task) SetType(v string) {
	o.Type = v
}

// GetBlocker returns the Blocker field value
func (o *Task) GetBlocker() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Blocker
}

// GetBlockerOk returns a tuple with the Blocker field value
// and a boolean to check if the value has been set.
func (o *Task) GetBlockerOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Blocker, true
}

// SetBlocker sets field value
func (o *Task) SetBlocker(v bool) {
	o.Blocker = v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise.
func (o *Task) GetCreatedAt() string {
	if o == nil || IsNil(o.CreatedAt) {
		var ret string
		return ret
	}
	return *o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetCreatedAtOk() (*string, bool) {
	if o == nil || IsNil(o.CreatedAt) {
		return nil, false
	}
	return o.CreatedAt, true
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *Task) HasCreatedAt() bool {
	if o != nil && !IsNil(o.CreatedAt) {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given string and assigns it to the CreatedAt field.
func (o *Task) SetCreatedAt(v string) {
	o.CreatedAt = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *Task) GetUpdatedAt() string {
	if o == nil || IsNil(o.UpdatedAt) {
		var ret string
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetUpdatedAtOk() (*string, bool) {
	if o == nil || IsNil(o.UpdatedAt) {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *Task) HasUpdatedAt() bool {
	if o != nil && !IsNil(o.UpdatedAt) {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given string and assigns it to the UpdatedAt field.
func (o *Task) SetUpdatedAt(v string) {
	o.UpdatedAt = &v
}

// GetOwnedBy returns the OwnedBy field value if set, zero value otherwise.
func (o *Task) GetOwnedBy() string {
	if o == nil || IsNil(o.OwnedBy) {
		var ret string
		return ret
	}
	return *o.OwnedBy
}

// GetOwnedByOk returns a tuple with the OwnedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetOwnedByOk() (*string, bool) {
	if o == nil || IsNil(o.OwnedBy) {
		return nil, false
	}
	return o.OwnedBy, true
}

// HasOwnedBy returns a boolean if a field has been set.
func (o *Task) HasOwnedBy() bool {
	if o != nil && !IsNil(o.OwnedBy) {
		return true
	}

	return false
}

// SetOwnedBy gets a reference to the given string and assigns it to the OwnedBy field.
func (o *Task) SetOwnedBy(v string) {
	o.OwnedBy = &v
}

// GetDestinationLink returns the DestinationLink field value if set, zero value otherwise.
func (o *Task) GetDestinationLink() string {
	if o == nil || IsNil(o.DestinationLink) {
		var ret string
		return ret
	}
	return *o.DestinationLink
}

// GetDestinationLinkOk returns a tuple with the DestinationLink field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetDestinationLinkOk() (*string, bool) {
	if o == nil || IsNil(o.DestinationLink) {
		return nil, false
	}
	return o.DestinationLink, true
}

// HasDestinationLink returns a boolean if a field has been set.
func (o *Task) HasDestinationLink() bool {
	if o != nil && !IsNil(o.DestinationLink) {
		return true
	}

	return false
}

// SetDestinationLink gets a reference to the given string and assigns it to the DestinationLink field.
func (o *Task) SetDestinationLink(v string) {
	o.DestinationLink = &v
}

// GetInterval returns the Interval field value if set, zero value otherwise.
func (o *Task) GetInterval() string {
	if o == nil || IsNil(o.Interval) {
		var ret string
		return ret
	}
	return *o.Interval
}

// GetIntervalOk returns a tuple with the Interval field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetIntervalOk() (*string, bool) {
	if o == nil || IsNil(o.Interval) {
		return nil, false
	}
	return o.Interval, true
}

// HasInterval returns a boolean if a field has been set.
func (o *Task) HasInterval() bool {
	if o != nil && !IsNil(o.Interval) {
		return true
	}

	return false
}

// SetInterval gets a reference to the given string and assigns it to the Interval field.
func (o *Task) SetInterval(v string) {
	o.Interval = &v
}

// GetScheduleType returns the ScheduleType field value if set, zero value otherwise.
func (o *Task) GetScheduleType() string {
	if o == nil || IsNil(o.ScheduleType) {
		var ret string
		return ret
	}
	return *o.ScheduleType
}

// GetScheduleTypeOk returns a tuple with the ScheduleType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetScheduleTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ScheduleType) {
		return nil, false
	}
	return o.ScheduleType, true
}

// HasScheduleType returns a boolean if a field has been set.
func (o *Task) HasScheduleType() bool {
	if o != nil && !IsNil(o.ScheduleType) {
		return true
	}

	return false
}

// SetScheduleType gets a reference to the given string and assigns it to the ScheduleType field.
func (o *Task) SetScheduleType(v string) {
	o.ScheduleType = &v
}

// GetAction returns the Action field value if set, zero value otherwise.
func (o *Task) GetAction() string {
	if o == nil || IsNil(o.Action) {
		var ret string
		return ret
	}
	return *o.Action
}

// GetActionOk returns a tuple with the Action field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetActionOk() (*string, bool) {
	if o == nil || IsNil(o.Action) {
		return nil, false
	}
	return o.Action, true
}

// HasAction returns a boolean if a field has been set.
func (o *Task) HasAction() bool {
	if o != nil && !IsNil(o.Action) {
		return true
	}

	return false
}

// SetAction gets a reference to the given string and assigns it to the Action field.
func (o *Task) SetAction(v string) {
	o.Action = &v
}

// GetUsages returns the Usages field value if set, zero value otherwise.
func (o *Task) GetUsages() []string {
	if o == nil || IsNil(o.Usages) {
		var ret []string
		return ret
	}
	return o.Usages
}

// GetUsagesOk returns a tuple with the Usages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetUsagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Usages) {
		return nil, false
	}
	return o.Usages, true
}

// HasUsages returns a boolean if a field has been set.
func (o *Task) HasUsages() bool {
	if o != nil && !IsNil(o.Usages) {
		return true
	}

	return false
}

// SetUsages gets a reference to the given []string and assigns it to the Usages field.
func (o *Task) SetUsages(v []string) {
	o.Usages = v
}

// GetElement returns the Element field value if set, zero value otherwise.
func (o *Task) GetElement() TaskElement {
	if o == nil || IsNil(o.Element) {
		var ret TaskElement
		return ret
	}
	return *o.Element
}

// GetElementOk returns a tuple with the Element field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetElementOk() (*TaskElement, bool) {
	if o == nil || IsNil(o.Element) {
		return nil, false
	}
	return o.Element, true
}

// HasElement returns a boolean if a field has been set.
func (o *Task) HasElement() bool {
	if o != nil && !IsNil(o.Element) {
		return true
	}

	return false
}

// SetElement gets a reference to the given TaskElement and assigns it to the Element field.
func (o *Task) SetElement(v TaskElement) {
	o.Element = &v
}

// GetTasksCompletions returns the TasksCompletions field value if set, zero value otherwise.
func (o *Task) GetTasksCompletions() []TaskCompletion {
	if o == nil || IsNil(o.TasksCompletions) {
		var ret []TaskCompletion
		return ret
	}
	return o.TasksCompletions
}

// GetTasksCompletionsOk returns a tuple with the TasksCompletions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Task) GetTasksCompletionsOk() ([]TaskCompletion, bool) {
	if o == nil || IsNil(o.TasksCompletions) {
		return nil, false
	}
	return o.TasksCompletions, true
}

// HasTasksCompletions returns a boolean if a field has been set.
func (o *Task) HasTasksCompletions() bool {
	if o != nil && !IsNil(o.TasksCompletions) {
		return true
	}

	return false
}

// SetTasksCompletions gets a reference to the given []TaskCompletion and assigns it to the TasksCompletions field.
func (o *Task) SetTasksCompletions(v []TaskCompletion) {
	o.TasksCompletions = v
}

func (o Task) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Task) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["organization_id"] = o.OrganizationId
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.ScriptId) {
		toSerialize["script_id"] = o.ScriptId
	}
	toSerialize["text"] = o.Text
	toSerialize["title"] = o.Title
	toSerialize["type"] = o.Type
	toSerialize["blocker"] = o.Blocker
	if !IsNil(o.CreatedAt) {
		toSerialize["created_at"] = o.CreatedAt
	}
	if !IsNil(o.UpdatedAt) {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	if !IsNil(o.OwnedBy) {
		toSerialize["owned_by"] = o.OwnedBy
	}
	if !IsNil(o.DestinationLink) {
		toSerialize["destination_link"] = o.DestinationLink
	}
	if !IsNil(o.Interval) {
		toSerialize["interval"] = o.Interval
	}
	if !IsNil(o.ScheduleType) {
		toSerialize["schedule_type"] = o.ScheduleType
	}
	if !IsNil(o.Action) {
		toSerialize["action"] = o.Action
	}
	if !IsNil(o.Usages) {
		toSerialize["usages"] = o.Usages
	}
	if !IsNil(o.Element) {
		toSerialize["element"] = o.Element
	}
	if !IsNil(o.TasksCompletions) {
		toSerialize["tasks_completions"] = o.TasksCompletions
	}
	return toSerialize, nil
}

type NullableTask struct {
	value *Task
	isSet bool
}

func (v NullableTask) Get() *Task {
	return v.value
}

func (v *NullableTask) Set(val *Task) {
	v.value = val
	v.isSet = true
}

func (v NullableTask) IsSet() bool {
	return v.isSet
}

func (v *NullableTask) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTask(val *Task) *NullableTask {
	return &NullableTask{value: val, isSet: true}
}

func (v NullableTask) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTask) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


